#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char *argv[]){
  FILE *pfi,*pfo;
  if (argc != 2){
    fprintf(stdout,"imprimo en el stdout\n"); /* es lo mismo que printf("imprimo en el stdour"\n); */
    fprintf(stderr,"Faltan parámetros\n uso: ./entradaSalida [nombreArchivo]\n");
    return(-1);
  }
  printf("archivo %s\n",argv[1]);
  pfi = fopen(argv[1],"r");
  char * nombreFileSalida;
  int len = strlen(argv[1]);
  nombreFileSalida = (char *)malloc(len+3); /* preveo que le voy a agregar 3 
					       caracteres al nombre Out */
  printf("nombre: %s -> ",argv[1]);
  strncpy(nombreFileSalida,argv[1],len-4); /*le saco el .txt */
  printf(" %s -> ",nombreFileSalida);
  strcat(nombreFileSalida,"Out.txt");
  printf(" %s \n",nombreFileSalida);
  pfo = fopen(nombreFileSalida,"w+");
    /* largo en bytes del archivo de apuntado por pfi*/
  int i;
  if (fseek(pfi,0,SEEK_END) != 0)
    fprintf(stderr,"error en fseek\n");
  i = ftell(pfi);
  /* vuelvo a poner en el origen el pfi */
  rewind(pfi);
  printf("tamano del archivo en bytes (i): %d\n",i);
  /* copia los caracteres de pfi a pfo en forma binaria */
  
  char leido;
    
  while (i--){
    fread(&leido,1,1,pfi);
    printf("el puntero de pfi esta en %d\n",(int)ftell(pfi)); 
   /*fprintf(stdout,"%c",leido); es lo mismo que printf("%c",leido);*/
    fwrite(&leido,1,1,pfo);
  }
  rewind(pfi);
  fclose(pfo);

  pfo = fopen(nombreFileSalida,"a");
printf("el puntero en pfo esta en %d\n",(int)ftell(pfo));
  printf("otra forma \n ");
  /* lee y escribe un char */
  int c;
  while (1){
    if((c=getc(pfi)) != EOF){
      putc(c,pfo);
    }
    else
      break;
  }
  fclose(pfo);
  fclose(pfi);

  printf("\n archivos binarios:\n");
  int tabla[100];
  for (i=0; i<100; i++)
    tabla[i] = i;

  FILE *pfBin, *pfFormateada;
  pfBin = fopen("tablaBinaria","wb");
  pfFormateada = fopen("tablaFormateada","w");
  for(i=0;i<100;i++){
    fprintf(pfFormateada,"%d",tabla[i]);
  }
 /* for(i=0;i<100;i++){
    fwrite(&tabla[i],sizeof(int),1,pfBin);
  }*/
  fwrite(tabla,sizeof(int),100,pfBin);
  fclose(pfBin);
  pfBin = fopen("tablaBinaria","rb");
  int lect;
  for(i=0;i<100;i++){
    fread(&lect,sizeof(int),1,pfBin);
    printf("%d ",lect);
  }

  fclose (pfBin);
  fclose (pfFormateada); 
  free(nombreFileSalida);
  return 0;
}
