#include <stdio.h>
#include <string.h>

enum tipo_pixel {COLOR, GRISES};

struct pixel_color {
  int rojo, verde, azul;/*reserva espacio en memoria para 3 enteros */
};

typedef struct{ /* reserva 2 enteros en memoria */
int x;
int y;
} pnt;

struct pixel{
  pnt coordenadas; /* aca reserva espacio para 2 enteros */
  enum tipo_pixel tipo; /*reserva para 1 */
  union {
    struct pixel_color color;
    int gris;
  } valor; /*reserva en memoria en este caso para 3 enteros porque el miembro color de la union es de          tamanio 3 y el miembro girs de la union es mas chico y cabe alli*/
};

typedef struct pixel Pixel;

void imprimir_pixel(Pixel pixel){
  switch (pixel.tipo) {
  case COLOR:
    {
      struct pixel_color *color = &pixel.valor.color;
      printf("pixel color (%d,%d,%d)\n", color->rojo, color->verde, color->azul);
    }
    break;
  case GRISES:
    printf("pixel gris: %d\n", pixel.valor.gris);
    break;
  default:
    printf("tipo desconocido;\n");
  }
}


int main (int argc, char *argv[]) {
  Pixel pixel;

  if (argc == 2){
    if (strcmp(argv[1],"gris") == 0)
      pixel.tipo = GRISES;
    else
      pixel.tipo = COLOR;
  }
  else{
    printf("uso: pixels [gris|color]\n");
    return(-1);
  }
    
  printf("argv[1] %s strcmp %d tipo %d\n",argv[1],strcmp(argv[1],"gris"),pixel.tipo);
  pixel.valor.color.rojo=255;	
  pixel.valor.color.verde=0;
  pixel.valor.color.azul=4;
  /*pixel.valor.gris = 125;*/
  
  imprimir_pixel(pixel);
  return 0;
}
